<?php

require_once('common.php');

if(!authorized()){
    return;
}

?>

<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <title>Turn it in - Available</title>
  <meta name="description" content="A module for submitting homework">
  <meta name="author"      content="World Possible">
  <meta name="viewport"    content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="../assets/css/normalize.css">
  <link rel="stylesheet" href="../assets/css/skeleton.css">
  <link rel="stylesheet" href="../assets/css/custom.css">
  <link rel="stylesheet" href="../assets/fontawesome/css/all.css">
  <link rel="icon" type="image/png" href="../assets/images/favicon.png">
  <script type="text/javascript" src="../assets/js/jquery-3.6.0.min.js"></script> 
  <!-- Jquery Filer-->
  <link rel="stylesheet" href="../css/jquery.filer.css">
  <link rel="stylesheet" href="../css/themes/jquery.filer-dragdropbox-theme.css">
  <script src="../js/jquery-latest.min.js"></script>
  <script src="../js/jquery.filer.min.js?v=1.0.5"></script>
  <script src="../js/custom.js?v=1.0.5"></script> 
  <!-- End of Jquery filer --> 
  
  <script>
    
  var lastSelect = true;
  
  function selectAll(){
      var checkboxes = document.getElementsByName('file_select');
     
      for(var i=0; i < checkboxes.length; i++) {
          checkboxes[i].checked = lastSelect;
      }
      
      lastSelect = !lastSelect;
  }
    
  function deleteSelectedDownloads(){
      var checkboxes   = document.getElementsByName('file_select');
      var checkedfiles = [];
     
      for(var i=0; i < checkboxes.length; i++) {
          if(checkboxes[i].checked){
              var file = checkboxes[i].value;
              checkedfiles.push(file);
          }
      }

      if(checkedfiles.length == 0){
          return
      }

      if (!confirm('Are you sure you want to delete all of the selected files?')) {
          return;
      } 

      var selectedFiles = JSON.stringify(checkedfiles);
      
      $.ajax({
        url: "process.php",
        data: { action: 'deleteSelectedDownloads', "selected": selectedFiles },
        type: "POST",
        dataType : "json",
        success: function(data) {
            location.reload();
            alert("Files successfully deleted");
            
        },
        error: function(response) {
            alert(response.responseJSON['responseText']);
        }
      });
  }
  
  function deleteDownload(name){
      $.ajax({
        url: "process.php",
        data: { action: 'deleteDownload', "name": name },
        type: "POST",
        success: function(data) {
            alert("The file was successfully deleted");
            location.reload();
        },
        error: function(response) {
            alert(response.responseJSON['responseText']);
        }
      });      
  }
  
  function getDownloads(){

    // Remove everything in the table
    $("#file_list").find("tr:gt(1)").remove();

    $.ajax({
        url: "process.php",
        data: { action: 'getFileDownloads' }, // So we use the proc version
        type: "POST",
        dataType : "json",
        success: function(data) {

            data.sort( function( a, b ) {
                a = a['name'].toLowerCase();
                b = b['name'].toLowerCase();

                return a < b ? -1 : a > b ? 1 : 0;
            });

            for(var i = 0; i < data.length; i++){
                var name   = data[i]['name'];
                var path   = "../student_downloads/" + name;
                var table  = "<tr>";
                table     += "<td><input type='checkbox' id='' name='file_select' value=\"" + name + "\"></td>"
                table     += "<td><a href=\"" + path + "\" >" + name + "</a></td>";  
                table     += "<td>" + data[i]['size'] + "</td>";
                table     += "<td>" + data[i]['changed'] + "</td>";
                table     += "<td><button title='Delete Download' class='button-2 small' onclick='deleteDownload(\"" + name + "\");'><i class='far fa-trash-alt'></i></button>";
                $('#file_list tr:last').after(table);
            }

            if(data.length > 0){
                // Add the "All Files" seection
                var table  = "<tr><td><input type='checkbox' id='file_all' name='file_select' onchange='selectAll()'></td>";         
                table     += "<td>All Files </td><td>&nbsp;</td><td>&nbsp;</td>";
                table     += "<td><button title='Delete Selected' class='button-2 small' onclick='deleteSelectedDownloads();'><i class='far fa-trash-alt'></i></button>";
                $('#file_list tr:last').after(table);
           }

           if(data.length == 0){
                $('#file_list tr:last').after('<tr><td>No files available</td></tr>');
           }
        },
        error: function(response) {
            $('#file_list tr:last').after('<tr><td>Error: ' +  response.responseJSON['responseText'] + '</td></tr>');
        }
    });
  }
  
  $(function() {
    getDownloads();
  });
  
  </script>

  
</head>
<body>
<?php include('navbar.php'); ?>
      <div class="section u-pull-left cf">
        <div class="container">
          <div class="row">
            <div class="six columns">
        
              <h3 class="section-heading  u-pull-left">Upload Assignments</h3><br><br>
              <p class="section-description u-pull-left">Teachers, upload assignments here (Max 2GB)</p>

              <div class='u-pull-left'>
                <form enctype="multipart/form-data" method="POST">
                 <input type="hidden" name="MAX_FILE_SIZE" value="300000000000" />
                  <input type="file" name="files[]" id="filer_input3" multiple="multiple">
                </form>
              </div>
              <ul>
                <li class="u-pull-left wrap">Potentially malicious file extensions are prohibited despite "success" during upload</li>
              </ul>
              
            </div>
            
            <div class="six columns">
              <h3 class="section-heading u-pull-left">Available to All</h3><br><br>
              <p class="section-description u-pull-left">The following files are available to all on the main "turn it in" page</p>
              <table id="file_list">
                 <th> </th>
                 <th>Name</th>
                 <th>Size</th>
                 <th>Last Modified</th>
              </table>
             </div>

        </div>

      </div>

      

</body>
</html>
