<?php


if(isset($_POST["common_action"])){
    $action = $_POST['common_action'];

    switch($action){
        case 'login':
            login();
            break;
        case 'getDownloads':
            getDownloads();
            break;
        default:
            error_exit(101, "common: No valid action provided");
    }
}

function authorized() {
    # if we've got a good cookie, return true
    if (isset($_COOKIE['teacher-auth']) && $_COOKIE['teacher-auth'] == "admin") {
        return true;
    } 
    
    if (isset($_POST['user']) && isset($_POST['pass'])) {
        $db        = getdb();
        $db_user   = $db->escapeString(strtolower($_POST['user']));
        $db_pass   = $db->escapeString(md5($_POST['pass']));
        
        $validuser = $db->querySingle(
            "SELECT * 
               FROM users 
              WHERE username = '$db_user' 
                AND password = '$db_pass'");

        if ($validuser) {
            setcookie("teacher-auth", "admin", 0, "/");
            header(
                "Location: //$_SERVER[HTTP_HOST]"
                . strtok($_SERVER["REQUEST_URI"],'?')
            );
            return true;
        }
    }    

print <<<EOT
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>Teacher Login</title>
    <link rel="stylesheet" href="../assets/fontawesome/css/all.css">
    <link rel="stylesheet" href="../assets/css/login.css">
    <link rel="icon" type="image/png" href="../assets/images/favicon.png">
    <script type="text/javascript" src="../assets/js/jquery-3.6.0.min.js"></script>
    <script>
        
    function login(){
        var user  = document.getElementById("user").value;  
        var pass  = document.getElementById("pass").value;
                
        $.ajax({
          url: "process.php",
          data: { common_action: 'login', "user": user, "pass": pass },
          type: "POST",
          success: function(data) {
            location.reload();
          },
          error: function(response) {
            alert(response.responseJSON['responseText']);
            location.reload();
          }
        });      
    }
      
    </script    
  </head>
  <body onload="document.getElementById('user').focus()">
    <div class="content">
      <table class="login"><tr>  
        <tr><td><i class="fas fa-chalkboard-teacher"></i> Teacher Login</td></tr>   
        <tr><td>&nbsp;&nbsp;&nbsp;&nbsp;</td></tr>
	    <tr>
	      <td><input type="text" name="user" id="user" placeholder="Username" ></td>
        </tr>
        
        <tr>
	      <td><input type="password" id="pass" placeholder="Password"></td>
        </tr>
	    <tr>
	      <td>
            <button class='button-primary button-2' onclick="login();">Log In</button>
	      </td>
	    </tr>
      </table>
	</div>
  </body>
</html>
EOT;

}

function login(){   
    if(!isset($_POST['user'])){
        error_exit(102, "authorize: No username provided"); 
    }
    
    if(!isset($_POST['pass'])){
        error_exit(103, "authorize: No password provided"); 
    }    
    
    $user = $_POST['user'];
    
    if(trim($user) == ""){
        error_exit(104, "authorize: Empty username provided"); 
    }
    
    if($user != "teacher"){
         error_exit(105, "authorize: wrong account name provided"); 
    }
    
    $pass      = $_POST['pass'];

    if(trim($pass) == ""){
        error_exit(106, "authorize: Empty password provided"); 
    }

    $db        = getdb();
    $db_user   = $db->escapeString(strtolower($user));
    $db_pass   = $db->escapeString(md5($pass));
    
    $validuser = $db->querySingle(
        "SELECT * 
           FROM users 
          WHERE username = '$db_user' 
            AND password = '$db_pass'");

    if (!$validuser) {
        error_exit(107, "authorize: Wrong credentials provided"); 
    }
    
    setcookie("teacher-auth", "admin", 0, "/");
    header("HTTP/1.1 200 OK");
    header('Content-Type: application/json; charset=UTF-8');

    $response = json_encode(["responseText" => "Logged in" ]);

    if(!$response){
        error_exit(108, "authorize: Failed to encode success response");
    }

    echo $response;
    die(); 
}

function getDownloads(){
    $upload_dir = dirname(__DIR__) . "/student_downloads/";
    $files      = scandir($upload_dir);
    $filenames  = array();
    
    foreach($files as $name){
        if($name == "." || $name == ".."){
            continue;
        }
        
        if($name == ".htaccess"){
            continue;
        }
        
        $file = $upload_dir. "/" . $name;
        

        array_push($filenames, $name);	
    }

    header("HTTP/1.1 200 OK");
    header('Content-Type: application/json; charset=UTF-8');

    $response = json_encode($filenames);

    if(!$response){
        error_exit(109, "getUploads: Failed to encode response");
    }

    echo $response;
    die();
}

# From content shell
function getdb() {
    global $_db;
    if (isset($_db)) { return $_db; }

    try {
        $dbfile = "db.sqlite";
        $_db    = new SQLite3($dbfile);
        @chmod($dbfile, 0666);
    } catch (Exception $ex) {
        error_log($ex->getMessage());
        error_log("DB File: $dbfile");
        return null;
    }

    $_db->busyTimeout(10000);
    $_db->exec("BEGIN");
    $_db->exec("
        CREATE TABLE IF NOT EXISTS users (
            user_id  INTEGER PRIMARY KEY,
            username VARCHAR(255) UNIQUE,
            password VARCHAR(255),
            level    INTEGER)");

    $teacher = $_db->querySingle("SELECT 1 FROM users WHERE username = 'teacher'");
    
    if (!$teacher) {
        $_db->exec("
            INSERT INTO users (username, password)
            VALUES ('teacher', 'd54f4a435aca0ed313c2a7a0b9914d78')
        ");
    }
    $_db->exec("
        CREATE TABLE IF NOT EXISTS settings (
            setting VARCHAR(255) UNIQUE,
            value   VARCHAR(255))");
    
    $_db->exec("COMMIT");
    return $_db;
}

function cleanup() {
    global $_db;
    if (isset($_db)) {
        $_db->close();
        unset($_db);
    }
}
register_shutdown_function('cleanup');

function error_exit($code, $error){
    header('HTTP/1.1 500 Internal Server');
    header('Content-Type: application/json; charset=UTF-8');

    $response = json_encode(["responseText" => $error, "code" => $code ]);

    if(!$response){
        error_log("Failed to encode json response with error: " . $error  . " and code: " . $code);
        die();
    }

    echo $response;
    die();                
}

?>